# class Bundler::LazySpecification

### Constants

Identifier

### Attributes

dependencies[R]
name[R]
platform[R]
remote[RW]
source[RW]
version[R]

### Public Class Methods

new(name, version, platform, source = nil) click to toggle source

    # File lib/bundler/lazy_specification.rb, line 29
    def initialize(name, version, platform, source = nil)
      @name          = name
      @version       = version
      @dependencies  = []
      @platform      = platform || Gem::Platform::RUBY
      @source        = source
      @specification = nil
    end

### Public Instance Methods

==(other) click to toggle source

    # File lib/bundler/lazy_specification.rb, line 46
    def ==(other)
      identifier == other.identifier
    end

__materialize__() click to toggle source

    # File lib/bundler/lazy_specification.rb, line 71
    def __materialize__
      search_object = Bundler.feature_flag.specific_platform? || Bundler.settings[:force_ruby_platform] ? self : Dependency.new(name, version)
      @specification = if source.is_a?(Source::Gemspec) && source.gemspec.name == name
        source.gemspec.tap {|s| s.source = source }
      else
        search = source.specs.search(search_object).last
        if search && Gem::Platform.new(search.platform) != Gem::Platform.new(platform) && !search.runtime_dependencies.-(dependencies.reject {|d| d.type == :development }).empty?
          Bundler.ui.warn "Unable to use the platform-specific (#{search.platform}) version of #{name} (#{version}) " \
            "because it has different dependencies from the #{platform} version. " \
            "To use the platform-specific version of the gem, run `bundle config specific_platform true` and install again."
          search = source.specs.search(self).last
        end
        search.dependencies = dependencies if search && (search.is_a?(RemoteSpecification) || search.is_a?(EndpointSpecification))
        search
      end
    end

full_name() click to toggle source

    # File lib/bundler/lazy_specification.rb, line 38
    def full_name
      if platform == Gem::Platform::RUBY || platform.nil?
        "#{@name}-#{@version}"
      else
        "#{@name}-#{@version}-#{platform}"
      end
    end

git_version() click to toggle source

    # File lib/bundler/lazy_specification.rb, line 104
    def git_version
      return unless source.is_a?(Bundler::Source::Git)
      " #{source.revision[0..6]}"
    end

identifier() click to toggle source

    # File lib/bundler/lazy_specification.rb, line 100
    def identifier
      @__identifier ||= Identifier.new(name, version, source, platform, dependencies)
    end

respond_to?(*args) click to toggle source
Calls superclass method `Object#respond_to?`

    # File lib/bundler/lazy_specification.rb, line 88
    def respond_to?(*args)
      super || @specification ? @specification.respond_to?(*args) : nil
    end

satisfies?(dependency) click to toggle source

    # File lib/bundler/lazy_specification.rb, line 50
    def satisfies?(dependency)
      @name == dependency.name && dependency.requirement.satisfied_by?(Gem::Version.new(@version))
    end

to_lock() click to toggle source

    # File lib/bundler/lazy_specification.rb, line 54
    def to_lock
      out = String.new

      if platform == Gem::Platform::RUBY || platform.nil?
        out << "    #{name} (#{version})\n"
      else
        out << "    #{name} (#{version}-#{platform})\n"
      end

      dependencies.sort_by(&:to_s).uniq.each do |dep|
        next if dep.type == :development
        out << "    #{dep.to_lock}\n"
      end

      out
    end

to_s() click to toggle source

    # File lib/bundler/lazy_specification.rb, line 92
    def to_s
      @__to_s ||= if platform == Gem::Platform::RUBY || platform.nil?
        "#{name} (#{version})"
      else
        "#{name} (#{version}-#{platform})"
      end
    end

### Private Instance Methods

method_missing(method, *args, &blk) click to toggle source
Calls superclass method `BasicObject#method_missing`

    # File lib/bundler/lazy_specification.rb, line 115
    def method_missing(method, *args, &blk)
      raise "LazySpecification has not been materialized yet (calling :#{method} #{args.inspect})" unless @specification

      return super unless respond_to?(method)

      @specification.send(method, *args, &blk)
    end

to_ary() click to toggle source

    # File lib/bundler/lazy_specification.rb, line 111
    def to_ary
      nil
    end